﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ValidationModelConsoleApp
{
    class Program
    {
        static void Main(string[] args)
        {
            ICollection<ValidationResult> results = null;

            User validUser = new User
            {
                Name = "Hellen",
                Age = 18,
            };

            if(!Validate(validUser, out results))
            {
                Console.WriteLine(string.Join("\n", results.Select(o=>o.ErrorMessage)));
            }
            else
            {
                Console.WriteLine("I am a valid object.");
            }

            Console.ReadKey();
        }

        static bool Validate<T>(T obj, out ICollection<ValidationResult> results)
        {
            results = new List<ValidationResult>();

            return Validator.TryValidateObject(obj, new ValidationContext(obj), results, true);
        }
    }

    public class User
    {
        [Required]
        [StringLength(20, ErrorMessage ="Out of range~")]
        public string Name { get; set; }

        [Range(1,120, ErrorMessage ="Not a valid age.")]
        public int Age { get; set; }
    }
}
